from dataclasses import dataclass, field

from .base import Paysite, Service_Post, Service_User


@dataclass
class User(Service_User):
    def profile(self, artist: dict) -> str:
        return f"https://www.pixiv.net/fanbox/creator/{(artist or {}).get('id')}"


@dataclass
class Post(Service_Post):
    def link(self, post_id: str, user_id: str) -> str:
        return f"https://www.pixiv.net/fanbox/creator/{user_id}/post/{post_id}"


@dataclass
class Fanbox(Paysite):
    name: str = "fanbox"
    title: str = "Pixiv Fanbox"
    user: User = field(default_factory=User)
    post: Post = field(default_factory=Post)
    color: str = "#2c333c"
